## libcxl 1.3

=== Makefile ===
srcdir = $(PWD)
include Makefile.vars

OBJS = libcxl.o libcxl_sysfs.o
CFLAGS += -I include

all: check_cxl_header libcxl.so libcxl.a

HAS_WGET = $(shell /bin/which wget > /dev/null 2>&1 && echo y || echo n)
HAS_CURL = $(shell /bin/which curl > /dev/null 2>&1 && echo y || echo n)

# Update this to test a single feature from the most recent header we require:
CHECK_CXL_HEADER_IS_UP_TO_DATE = $(shell /bin/echo -e \\\#include $(1)\\\nvoid test\(struct cxl_afu_id test\)\; | \
                 $(CC) $(CFLAGS) -Werror -x c -S -o /dev/null - > /dev/null 2>&1 && echo y || echo n)

check_cxl_header:
ifeq ($(call CHECK_CXL_HEADER_IS_UP_TO_DATE,"<misc/cxl.h>"),n)
	mkdir -p include/misc
ifeq (${HAS_WGET},y)
	$(call Q,WGET include/misc/cxl.h, wget -O include/misc/cxl.h -q http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/plain/include/uapi/misc/cxl.h)
else ifeq (${HAS_CURL},y)
	$(call Q,CURL include/misc/cxl.h, curl -o include/misc/cxl.h -s http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/plain/include/uapi/misc/cxl.h)
else
	$(error 'cxl.h is non-existant or out of date, Download from http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/plain/include/uapi/misc/cxl.h and place in ${PWD}/include/misc/cxl.h')
endif
endif

libcxl.o libcxl_sysfs.o : CFLAGS += -fPIC

libcxl.so: libcxl.o libcxl_sysfs.o symver.map
	$(call Q,CC, $(CC) $(CFLAGS) -shared libcxl.o libcxl_sysfs.o -o libcxl.so, libcxl.so) -Wl,--version-script symver.map

libcxl.a: libcxl.o libcxl_sysfs.o
	$(call Q,AR, ar rcs libcxl.a libcxl.o libcxl_sysfs.o, libcxl.a)

include Makefile.rules

clean:
	rm -f *.o *.d libcxl.so libcxl.a include/misc/cxl.h

.PHONY: clean all

=== man3/Makefile ===
SRC = $(wildcard *.3)
HTML = $(SRC:.3=.3.html)
TXT = $(SRC:.3=.3.txt)

all: $(HTML) $(TXT)

clean:
	rm -f *.3.html *.3.txt

%.3.html: %.3
	man2html -r <$< >$@; [ -s $@ ]

%.3.txt: %.3
	./man2txt <$< >$@; [ -s $@ ]

cxl.3.txt: cxl.3
	./man2txt <$< | ./foldtbl >$@; [ -s $@ ]

cxl_for_each_adapter.3.html: cxl_adapter_next.3.html
	cp -f $< $@

cxl_for_each_adapter_afu.3.html: cxl_adapter_afu_next.3.html
	cp -f $< $@

cxl_for_each_afu.3.html: cxl_afu_next.3.html
	cp -f $< $@

.PHONY: all clean

=== debian/changelog ===
libcxl (1.3-0ubuntu2) xenial; urgency=medium

  * debian/rules: override dh_makeshlibs to force dpkg-gensymbols to fail if
    symbols appear that were not added to the symbols file.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 29 Mar 2016 14:03:09 -0400

libcxl (1.3-0ubuntu1) xenial; urgency=medium

  * Upload libcxl to xenial; from the package at Debian mentors. (LP: #1541457)
  * Removed libcxl.a from files to ship.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 16 Feb 2016 14:15:57 -0500

libcxl (1.3-1) UNRELEASED; urgency=medium

  * Initial release (Closes: #813592)

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Mon, 01 Feb 2016 15:22:26 +0100

=== debian/control ===
Source: libcxl
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
Build-Depends: debhelper (>=9)
Standards-Version: 3.9.6
Section: libs
Homepage: https://github.com/ibm-capi/libcxl
#Vcs-Git: git://anonscm.debian.org/collab-maint/libcxl.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libcxl.git

Package: libcxl-dev
Section: libdevel
Architecture: ppc64 ppc64el
Depends: libcxl1 (= ${binary:Version}), ${misc:Depends}
Description: Coherent accelerator shared library development files
 The coherent accelerator interface is designed to allow the coherent
 connection of accelerators (FPGAs and other devices) to a POWER system.
 Coherent in this context means that the accelerator and CPUs can both access
 system memory directly and with the same effective addresses. IBM refers to
 this as the Coherent Accelerator Processor Interface (CAPI). In the Linux
 world it is referred to by the name CXL to avoid confusion with the ISDN
 CAPI subsystem.
 .
 This package provides development files for libcxl.

Package: libcxl1
Architecture: ppc64 ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Coherent accelerator shared library
 The coherent accelerator interface is designed to allow the coherent
 connection of accelerators (FPGAs and other devices) to a POWER system.
 Coherent in this context means that the accelerator and CPUs can both access
 system memory directly and with the same effective addresses. IBM refers to
 this as the Coherent Accelerator Processor Interface (CAPI). In the Linux
 world it is referred to by the name CXL to avoid confusion with the ISDN
 CAPI subsystem.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

VERS_LIB ?= 1.3
VERS_SONAME ?= 1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR ?= lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ 

override_dh_auto_clean:
	dh_auto_clean
	rm -f libcxl.so.$(VERS_LIB)

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_auto_build:
	make VERS_SONAME=$(VERS_SONAME) VERS_LIB=$(VERS_LIB)

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(CURDIR)/debian/tmp/usr/$(LIBDIR) $(CURDIR)/debian/tmp/usr/include
	cp libcxl.so.$(VERS_LIB) $(CURDIR)/debian/tmp/usr/$(LIBDIR)
	cp libcxl.h $(CURDIR)/debian/tmp/usr/include
	cd $(CURDIR)/debian/tmp/usr/$(LIBDIR) && ln -sf libcxl.so.$(VERS_LIB) libcxl.so.1
	cd $(CURDIR)/debian/tmp/usr/$(LIBDIR) && ln -sf libcxl.so.1 libcxl.so

## libcxl 1.4

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,16 @@
 OBJS = libcxl.o libcxl_sysfs.o
 CFLAGS += -I include
 
-all: check_cxl_header libcxl.so libcxl.a
+# change VERS_LIB if new git tag
+VERS_LIB = 1.4
+LIBNAME   = libcxl.so.$(VERS_LIB)
+# change VERS_SONAME only if library breaks backward compatibility.
+# refer to file symver.map
+VERS_SONAME=1
+LIBSONAME = libcxl.so.$(VERS_SONAME)
+SONAMEOPT = -Wl,-soname,$(LIBSONAME)
+
+all: check_cxl_header $(LIBNAME) libcxl.so libcxl.a
 
 HAS_WGET = $(shell /bin/which wget > /dev/null 2>&1 && echo y || echo n)
 HAS_CURL = $(shell /bin/which curl > /dev/null 2>&1 && echo y || echo n)
@@ -27,8 +36,11 @@
 
 libcxl.o libcxl_sysfs.o : CFLAGS += -fPIC
 
-libcxl.so: libcxl.o libcxl_sysfs.o symver.map
-	$(call Q,CC, $(CC) $(CFLAGS) -shared libcxl.o libcxl_sysfs.o -o libcxl.so, libcxl.so) -Wl,--version-script symver.map
+libcxl.so: $(LIBNAME)
+	ln -s $(LIBNAME) libcxl.so
+
+$(LIBNAME): libcxl.o libcxl_sysfs.o symver.map
+	$(call Q,CC, $(CC) $(CFLAGS) $(LDFLAGS) -shared libcxl.o libcxl_sysfs.o -o $(LIBNAME), $(LIBNAME)) -Wl,--version-script symver.map $(SONAMEOPT)
 
 libcxl.a: libcxl.o libcxl_sysfs.o
 	$(call Q,AR, ar rcs libcxl.a libcxl.o libcxl_sysfs.o, libcxl.a)
@@ -38,4 +50,11 @@
 clean:
 	rm -f *.o *.d libcxl.so libcxl.a include/misc/cxl.h
 
-.PHONY: clean all
+install: all
+	mkdir -p $(DESTDIR)$(libdir)
+	mkdir -p $(DESTDIR)$(includedir)
+	install -m 0755 $(LIBNAME) $(DESTDIR)$(libdir)/
+	cp -d libcxl.so $(DESTDIR)$(libdir)/
+	install -m 0644 libcxl.h  $(DESTDIR)$(includedir)/
+
+.PHONY: clean all install

=== debian/changelog ===
libcxl (1.4-1) unstable; urgency=medium

  * Initial release (Closes: #813592)

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Mon, 01 Feb 2016 15:22:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: libcxl
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
+Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
 Build-Depends: debhelper (>=9)
 Standards-Version: 3.9.6
 Section: libs

## libcxl 1.5

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 CFLAGS += -I include
 
 # change VERS_LIB if new git tag
-VERS_LIB = 1.4
+VERS_LIB = 1.5
 LIBNAME   = libcxl.so.$(VERS_LIB)
 # change VERS_SONAME only if library breaks backward compatibility.
 # refer to file symver.map
@@ -13,7 +13,7 @@
 LIBSONAME = libcxl.so.$(VERS_SONAME)
 SONAMEOPT = -Wl,-soname,$(LIBSONAME)
 
-all: check_cxl_header $(LIBNAME) libcxl.so libcxl.a
+all: check_cxl_header $(LIBSONAME) libcxl.so libcxl.a
 
 HAS_WGET = $(shell /bin/which wget > /dev/null 2>&1 && echo y || echo n)
 HAS_CURL = $(shell /bin/which curl > /dev/null 2>&1 && echo y || echo n)
@@ -37,7 +37,10 @@
 libcxl.o libcxl_sysfs.o : CFLAGS += -fPIC
 
 libcxl.so: $(LIBNAME)
-	ln -s $(LIBNAME) libcxl.so
+	ln -sf $(LIBNAME) libcxl.so
+
+$(LIBSONAME): $(LIBNAME)
+	ln -sf $(LIBNAME) $(LIBSONAME)
 
 $(LIBNAME): libcxl.o libcxl_sysfs.o symver.map
 	$(call Q,CC, $(CC) $(CFLAGS) $(LDFLAGS) -shared libcxl.o libcxl_sysfs.o -o $(LIBNAME), $(LIBNAME)) -Wl,--version-script symver.map $(SONAMEOPT)
@@ -48,13 +51,13 @@
 include Makefile.rules
 
 clean:
-	rm -f *.o *.d libcxl.so libcxl.a include/misc/cxl.h
+	rm -f *.o *.d libcxl.so* libcxl.a include/misc/cxl.h
 
 install: all
 	mkdir -p $(DESTDIR)$(libdir)
 	mkdir -p $(DESTDIR)$(includedir)
 	install -m 0755 $(LIBNAME) $(DESTDIR)$(libdir)/
-	cp -d libcxl.so $(DESTDIR)$(libdir)/
+	cp -d libcxl.so $(LIBSONAME) $(DESTDIR)$(libdir)/
 	install -m 0644 libcxl.h  $(DESTDIR)$(includedir)/
 
 .PHONY: clean all install

=== man3/Makefile ===
--- 
+++ 
@@ -25,4 +25,10 @@
 cxl_for_each_afu.3.html: cxl_afu_next.3.html
 	cp -f $< $@
 
-.PHONY: all clean
+include ../Makefile.rules
+
+install:
+	mkdir -p $(DESTDIR)$(mandir)/man3
+	install -m 0644 $(SRC) $(DESTDIR)$(mandir)/man3/
+
+.PHONY: all clean install

=== debian/changelog ===
libcxl (1.5-1) unstable; urgency=medium

  * New upstream release
  * d/patches/create-LIBSONAME-link.patch : dropped as applied upstream
  * d/control : Standards-Version updated to 3.9.8 but nothing needed to be
    changed

 -- Frédéric Bonnard <frediz@linux.vnet.ibm.com>  Tue, 30 May 2017 13:02:18 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: libcxl
 Priority: optional
-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
+Maintainer: Frédéric Bonnard <frediz@linux.vnet.ibm.com>
 Build-Depends: debhelper (>=9)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: libs
 Homepage: https://github.com/ibm-capi/libcxl
 #Vcs-Git: git://anonscm.debian.org/collab-maint/libcxl.git

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libcxl-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/ \
  https://github.com/ibm-capi/libcxl/tags .*/v?(\d\S*)\.tar\.gz

## libcxl 1.7

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 CFLAGS += -I include
 
 # change VERS_LIB if new git tag
-VERS_LIB = 1.5
+VERS_LIB = 1.7
 LIBNAME   = libcxl.so.$(VERS_LIB)
 # change VERS_SONAME only if library breaks backward compatibility.
 # refer to file symver.map
@@ -19,8 +19,8 @@
 HAS_CURL = $(shell /bin/which curl > /dev/null 2>&1 && echo y || echo n)
 
 # Update this to test a single feature from the most recent header we require:
-CHECK_CXL_HEADER_IS_UP_TO_DATE = $(shell /bin/echo -e \\\#include $(1)\\\nvoid test\(struct cxl_afu_id test\)\; | \
-                 $(CC) $(CFLAGS) -Werror -x c -S -o /dev/null - > /dev/null 2>&1 && echo y || echo n)
+CHECK_CXL_HEADER_IS_UP_TO_DATE = $(shell /bin/echo -e \\\#include $(1)\\\nint i = CXL_START_WORK_TID\; | \
+                 $(CC) $(CFLAGS) -Werror -x c -S -o /dev/null - >/dev/null 2>&1 && echo y || echo n)
 
 check_cxl_header:
 ifeq ($(call CHECK_CXL_HEADER_IS_UP_TO_DATE,"<misc/cxl.h>"),n)

=== debian/changelog ===
libcxl (1.7-1) unstable; urgency=medium

  * Remove unused d/patches effectively
  * Add support for the upstream version tags
  * Add new symbols to debian symbol file
  * Update Maintainer and Vcs info
  * Update copyright information
  * Upgrade debhelper compatibility level
  * Add Multi-Arch field
  * Upgrade Standards-Version

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 17 May 2018 16:31:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: libcxl
 Priority: optional
-Maintainer: Frédéric Bonnard <frediz@linux.vnet.ibm.com>
-Build-Depends: debhelper (>=9)
-Standards-Version: 3.9.8
+Maintainer: Frédéric Bonnard <frediz@debian.org>
+Build-Depends: debhelper (>=11~)
+Standards-Version: 4.1.4
 Section: libs
 Homepage: https://github.com/ibm-capi/libcxl
-#Vcs-Git: git://anonscm.debian.org/collab-maint/libcxl.git
-#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libcxl.git
+Vcs-Git: https://salsa.debian.org/debian/libcxl.git
+Vcs-Browser: https://salsa.debian.org/debian/libcxl
 
 Package: libcxl-dev
 Section: libdevel
 Architecture: ppc64 ppc64el
+Multi-Arch: same
 Depends: libcxl1 (= ${binary:Version}), ${misc:Depends}
 Description: Coherent accelerator shared library development files
  The coherent accelerator interface is designed to allow the coherent
@@ -25,6 +26,7 @@
 
 Package: libcxl1
 Architecture: ppc64 ppc64el
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Coherent accelerator shared library
  The coherent accelerator interface is designed to allow the coherent

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ 

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_auto_install:
	dh_auto_install -- libdir=/usr/lib/$(DEB_HOST_MULTIARCH) prefix=/usr
